/***************************************************************************
 *   Copyright (C) 2009 by Stephen Allewell                                *
 *   stephen@mirramar.fsnet.co.uk                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef LIBRARYLISTVIEW_H
#define LIBRARYLISTVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <klistview.h>

class QTimer;

class LibraryListView : public KListView
{
    Q_OBJECT

public:
    LibraryListView(QWidget *parent, QString name);

protected:
    virtual void contentsDragEnterEvent(QDragEnterEvent *event);
    virtual void contentsDragMoveEvent(QDragMoveEvent *event);
    virtual void contentsDragLeaveEvent(QDragLeaveEvent *event);
    virtual void contentsDropEvent(QDropEvent *event);
    virtual bool acceptDrag(QDropEvent *event) const;

private slots:
    void slotOpenBranch();

private:
    QListViewItem *m_dropItem;
    QListViewItem *m_currentItem;
    QTimer        *m_openBranchTimer;
};

#endif
