/***************************************************************************
 *   Copyright (C) 2003 by Stephen Allewell                                *
 *   stephen@mirramar.fsnet.co.uk                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef LIBRARYPATTERN_H
#define LIBRARYPATTERN_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qcstring.h>
#include <qdatastream.h>

class KIconViewItem;

class LibraryPattern
{
public:
  LibraryPattern(Q_INT32 key, Qt::ButtonState modifiers, Q_INT16 baseline, Q_UINT16 checksum, QByteArray &data);
  Q_INT32 key();
  Qt::ButtonState modifiers();
  void setKeyModifiers(Q_INT32 key, Qt::ButtonState modifiers);
  Q_INT16 baseline();
  void setBaseline(Q_INT16 baseline);
  Q_UINT16 checksum();
  QByteArray data();
  QString scheme();
  unsigned width();
  unsigned height();
  KIconViewItem *iconViewItem();
  void setIconViewItem(KIconViewItem *item);
  bool hasChanged();

private:
  Q_INT32 m_key;
  Qt::ButtonState m_modifiers;
  Q_INT16 m_baseline;
  Q_UINT16 m_checksum;
  QByteArray m_data;
  QString m_scheme;
  Q_UINT32 m_width;
  Q_UINT32 m_height;
  KIconViewItem *m_iconViewItem;
  bool m_changed;
};

#endif
